// игра дорога на ESP32
#include <Adafruit_GFX.h>    // Core graphics library
#include <Adafruit_ST7735.h> // Hardware-specific library
#include <SPI.h>
#include "ris_.h"//файл хранения массивов
#define TFT_CS     5
#define TFT_RST    16  
#define TFT_DC     17
#define KN         25 // под кнопки можно выводы 4,25,26  
// TFT_SCL 18   // 
// TFT_SDA 23   // 

 Adafruit_ST7735 tft = Adafruit_ST7735(TFT_CS,  TFT_DC, TFT_RST);
#define ZVET_1  tft.Color565(255,255,255)//цвет разметки
#define ZVET_2  tft.Color565(127,127,127)// цвет дороги
#define ZVET_3  tft.Color565(150,200,0)// цвет обочины

long Yv=0;//переменная хранения моментов времени
long Ykn=0;//переменная хранения моментов времени
long Ym=0;//переменная хранения моментов времени
long Ym2=0;//переменная хранения моментов времени
bool fl_1=true;//
bool fl_2=true;//
bool fl_kn=true;//
bool fl_3=false;//
bool fl_m1=1;//выбор цвета машины по флагу
bool fl_m2=1;//выбор цвета машины по флагу
byte tv=6;//переменная скорости движения
int x=32;//
byte st=0;//счётчик столкновений
int stm=0;//счётчик всего проехавших  машин  до очередного столкновения
 byte MAXstm=0;//счётчик  максимально всего проехавших  машин  до очередного столкновения
//

int x1=132;//
int x2=200;//

//
void setup(void) {
  pinMode (KN, INPUT_PULLUP);//игровая кнопка 
  // Используйте этот инициализатор, если вы используете 1,8-дюймовый TFT
 tft.initR(INITR_BLACKTAB);   // initialize a ST7735S chip, black tab
 tft.cp437(true);//для правильного отображения русского алфавита
 tft.fillScreen(ST7735_BLACK);
 //
 tft.setRotation(1);//ориентация экрана 
tft.setCursor(90, 5); tft.setTextSize(1); tft.setTextColor(ST7735_ORANGE);tft.println(utf8rus("АВАРИЙНОСТЬ"));
tft.fillRect(115,17,20,100,ST7735_ORANGE);//индикатор аварийности
//tft.fillRect(117,19,16,96,ST7735_BLACK);
 //
 tft.setRotation(0);//ориентация экрана
 tft.fillRect(0,10,128,62,ZVET_2);//дорога
 tft.fillRect(0,0,128,10,ZVET_3);//обочина
 tft.fillRect(0,70,128,10,ZVET_3);//обочина
 //
 drawBitmap_(0,45,ris_2,32,24,1);//
 
 }
void loop() {
  ////перемещение машинки игрока с одной полосы дороги на другую кнопкой
 if(digitalRead(KN)==LOW&&fl_kn==true){
 fl_kn=false;Ykn=millis();fl_2=!fl_2;
 fl_3=false;//
 if(!fl_2){tft.fillRect(0,45,32,24,ZVET_2);drawBitmap_(0,12,ris_2,32,24,1);}else{tft.fillRect(0,12,32,24,ZVET_2);drawBitmap_(0,45,ris_2,32,24,1);}
 byte slu=random(0,2);
  //...............вариант генерации №1
 if(x1<0&&fl_2&&slu==0){x1=128+10*random(1,4);fl_m1=random(0,2);}//условие генерации другой машинки случайного цвета 
 if(x2<0&&!fl_2&&slu==0){x2=128+30*random(3,6);fl_m2=random(0,2);}//условие генерации по встречной полосе другой машинки 
 //................вариант генерации №2
 if(x1<0&&x2<0&&slu>0){x1=128+10*random(1,4);x2=128+30*random(3,6);fl_m1=random(0,2);fl_m2=random(0,2);} 
 }
 //................вариант генерации №3
 if(x1<-500&&x2<-500){x1=128+10*random(3,6);x2=128+10*random(1,4);fl_3=false;fl_m1=random(0,2);fl_m2=random(0,2);}
 //
 if(millis()-Ykn>200){fl_kn=true;}
 ////движение другой машинки
if(millis()-Ym>2.3*tv){
 Ym=millis(); 
 if(x1==-1){if(!fl_2){tft.fillRect(0,45,32,24,ZVET_2);}else{drawBitmap_(0,45,ris_2,32,24,1);}stm++;}
 if(fl_m1){drawBitmap_(x1,45,ris_2,32,24,2);}else{drawBitmap_(x1,45,ris_2,32,24,1);}x1=x1-1;
}
////движение другой машинки по встречной полосе
if(millis()-Ym2>0.6*tv){
 Ym2=millis(); 
 if(x2==-1){if(fl_2){tft.fillRect(0,12,32,24,ZVET_2);}else{drawBitmap_(0,12,ris_2,32,24,1);}stm++;}
 if(fl_m2){drawBitmap_(x2,12,ris_3,32,24,1);}else{drawBitmap_(x2,12,ris_3,32,24,2);}x2=x2-1;
}
 ////движение полотна дороги
 if(millis()-Yv>tv){
 Yv=millis();
if(fl_1){  
tft.fillRect(x,40,1,2,ZVET_1);
tft.fillRect(x+32,40,1,2,ZVET_2);
tft.fillRect(x+64,40,1,2,ZVET_1);
tft.fillRect(x+96,40,1,2,ZVET_2);
 }
else{
tft.fillRect(x,40,1,2,ZVET_2);
tft.fillRect(x+32,40,1,2,ZVET_1);
tft.fillRect(x+64,40,1,2,ZVET_2);
tft.fillRect(x+96,40,1,2,ZVET_1);  
}
x--;if(x==0){x=32;fl_1=!fl_1;}
}
////счётчик столкновений машин и отрисовка аварийности 
if((x1<25&&x1>10&&!fl_3&&fl_2)||(x2<25&&x2>10&&!fl_3&&!fl_2)){
fl_3=true;
tft.setRotation(1);//ориентация экрана 

st++;

tft.fillRect(115,17,20,100,ST7735_ORANGE);//индикатор аварийности
if(stm>48){stm=48;}//
if(stm>MAXstm){MAXstm=stm;}//
tft.fillRect(117,19,16,2*stm,ST7735_BLACK);
tft.fillRect(120,19,10,2*MAXstm,ST7735_BLACK);
stm=0;
tft.setRotation(0);
}
////
}
/////////////////////////////////////////////////////////////////////
void drawBitmap_(int x,int y, const uint8_t *bitmap,int w,int h,byte pal) {//функция вывода 4-х цветного рисунка по координатам, заданного размера и выбранной палитры
if(x<0||x+w>128||y<0||y+h>160){return;} 
 tft.setAddrWindow(x,y,x+w-1,y+h-1);
 int i, j, byteWidth = (w + 7) / 8;
  uint8_t byte_r;uint8_t byte_g;uint8_t byte_b;
   //
  SPI.beginTransaction(SPISettings(40000000, MSBFIRST, SPI_MODE0));
  digitalWrite(TFT_DC, HIGH);
  digitalWrite(TFT_CS, LOW); 
 for(j=0; j<h; j++) {
    for(i=0; i<w; i++) {
      if(i & 7) {byte_r <<= 1;byte_g <<= 1;}
      else     { byte_r = pgm_read_byte(bitmap + j * byteWidth + i / 8);byte_g = pgm_read_byte(bitmap + (j+h) * byteWidth + i / 8);}
      if((byte_r&0x80)&&(byte_g&0x80))
      {if(pal==1){SPI.transfer(ZVET_1>>8);SPI.transfer(ZVET_1);}if(pal==2){SPI.transfer(tft.Color565(0,0,255)>>8);SPI.transfer(tft.Color565(0,0,255));}}//контур
      if(!(byte_r&0x80)&&!(byte_g&0x80))
      {if(pal==1){SPI.transfer(ZVET_2>>8);SPI.transfer(ZVET_2);}if(pal==2){SPI.transfer(ZVET_2>>8);SPI.transfer(ZVET_2);}}//фон
      if((byte_r&0x80)&&!(byte_g&0x80))
      {if(pal==1){SPI.transfer(tft.Color565(255,0,0)>>8);SPI.transfer(tft.Color565(255,0,0));}if(pal==2){SPI.transfer(tft.Color565(0,155,255)>>8);SPI.transfer(tft.Color565(0,155,255));}}//цвет 1
      if(!(byte_r&0x80)&&(byte_g&0x80))
      {if(pal==1){SPI.transfer(tft.Color565(250,250,0)>>8);SPI.transfer(tft.Color565(250,250,0));}if(pal==2){SPI.transfer(tft.Color565(0,255,100)>>8);SPI.transfer(tft.Color565(0,255,100));}}//цвет 2
      
    }
  }
  digitalWrite(TFT_CS, HIGH);
  SPI.endTransaction();
 ///  
}
////////////////////////////////////////////////////////////////////
/* Функция перекодировки русских букв из UTF-8 в Win-1251 */
String utf8rus(String source)
{
  int i,k;
  String target;
  unsigned char n;
  char m[2] = { '0', '\0' };

  k = source.length(); i = 0;

  while (i < k) {
    n = source[i]; i++;

    if (n >= 0xC0) {
      switch (n) {
        case 0xD0: {
          n = source[i]; i++;
          if (n == 0x81) { n = 0xA8; break; }
          if (n >= 0x90 && n <= 0xBF) n = n + 0x30;
          break;
        }
        case 0xD1: {
          n = source[i]; i++;
          if (n == 0x91) { n = 0xB8; break; }
          if (n >= 0x80 && n <= 0x8F) n = n + 0x70;
          break;
        }
      }
    }
    m[0] = n; target = target + String(m);
  }
return target;
}
////////////////////////////////////////////////////////////////////
