//презентация фотокартинок
#include <Adafruit_GFX.h>
#include <Adafruit_ST7735.h>
#include <SPI.h>
#include "ris_.h"//файл хранения массивов фотокартинок
#define TFT_CS     5
#define TFT_RST    16
#define TFT_DC     17
// TFT_SCL 18   
// TFT_SDA 23 
Adafruit_ST7735 tft = Adafruit_ST7735(TFT_CS,  TFT_DC, TFT_RST);
void setup() {
 tft.initR(INITR_BLACKTAB);
  tft.setRotation(0);
 tft.fillScreen(tft.Color565(0,0,0)); 
  }
void loop() {

// №1
for(byte flag=0;flag<4;flag++){  
for(int n=0;n<=128;n=n+2){
if(flag==0){drawFoto_fragment(128-n,128-n,ris_1,128,160,0,0,n,n+32);delay(20);}//влево-вверх
if(flag==1){drawFoto_fragment(0,0,ris_2,128,160,128-n,128-n,n,n+32);delay(20);}//вправо-вниз
if(flag==2){drawFoto_fragment(128-n,0,ris_3,128,160,0,128-n,n,n+32);delay(20);}//влево-вниз
if(flag==3){drawFoto_fragment(0,128-n,ris_4,128,160,128-n,0,n,n+32);delay(20);}//вправо-вверх 
} 
delay(2000);
}
//№2
byte N[]={9,7,13,0,2,6,12,15,4,10,1,8,5,11,14,3};//последовательность появления плиток 
for(byte flag=0;flag<4;flag++){  
for(int n=0;n<16;n++){
if(flag==0){drawFoto_fragment((N[n]/4)*32,(N[n]%4)*40,ris_1,128,160,(N[n]/4)*32,(N[n]%4)*40,32,40);delay(200);}//
if(flag==1){drawFoto_fragment((N[n]/4)*32,(N[n]%4)*40,ris_2,128,160,(N[n]/4)*32,(N[n]%4)*40,32,40);delay(200);}//
if(flag==2){drawFoto_fragment((N[n]/4)*32,(N[n]%4)*40,ris_3,128,160,(N[n]/4)*32,(N[n]%4)*40,32,40);delay(200);}//
if(flag==3){drawFoto_fragment((N[n]/4)*32,(N[n]%4)*40,ris_4,128,160,(N[n]/4)*32,(N[n]%4)*40,32,40);delay(200);}//
} 
delay(2000);
}
// №3
for(byte flag=0;flag<4;flag++){  
for(int n=0;n<=64;n++){
if(flag==0){drawFoto_fragment(64-n,64-n,ris_1,128,160,64-n,64-n,2*n,2*n+32);delay(20);}//
if(flag==1){drawFoto_fragment(64-n,64-n,ris_2,128,160,64-n,64-n,2*n,2*n+32);delay(20);}//
if(flag==2){drawFoto_fragment(64-n,64-n,ris_3,128,160,64-n,64-n,2*n,2*n+32);delay(20);}//
if(flag==3){drawFoto_fragment(64-n,64-n,ris_4,128,160,64-n,64-n,2*n,2*n+32);delay(20);}//
} 
delay(2000);
}

// №4
for(byte flag=0;flag<4;flag++){  
for(int n=0;n<=64;n=n+2){
if(flag==0){
  drawFoto_fragment(64,144-n,ris_1,128,160,64,80,64,n+16);
  drawFoto_fragment(0,0,ris_1,128,160,0,64-n,64,n+16);
  drawFoto_fragment(128-n,0,ris_1,128,160,64,0,n,80);
  drawFoto_fragment(0,80,ris_1,128,160,64-n,80,n,80);
 }
 if(flag==1){
  drawFoto_fragment(64,144-n,ris_2,128,160,64,80,64,n+16);
  drawFoto_fragment(0,0,ris_2,128,160,0,64-n,64,n+16);
  drawFoto_fragment(128-n,0,ris_2,128,160,64,0,n,80);
  drawFoto_fragment(0,80,ris_2,128,160,64-n,80,n,80);
 }
 if(flag==2){
  drawFoto_fragment(64,144-n,ris_3,128,160,64,80,64,n+16);
  drawFoto_fragment(0,0,ris_3,128,160,0,64-n,64,n+16);
  drawFoto_fragment(128-n,0,ris_3,128,160,64,0,n,80);
  drawFoto_fragment(0,80,ris_3,128,160,64-n,80,n,80);
 }
 if(flag==3){
  drawFoto_fragment(64,144-n,ris_4,128,160,64,80,64,n+16);
  drawFoto_fragment(0,0,ris_4,128,160,0,64-n,64,n+16);
  drawFoto_fragment(128-n,0,ris_4,128,160,64,0,n,80);
  drawFoto_fragment(0,80,ris_4,128,160,64-n,80,n,80);
 }
} 
delay(2000);
}
//
}
 
/////////////////////////////////////////////////////////////////
//функция вывода фрагмента фотокартинки размером w*h,x,y - положение фрагмента на экране, x1,y1,w1,h1 - выбор фрагмента из массива
void drawFoto_fragment(int x,int y, const uint8_t *bitmap,int w,int h,int x1,int y1,int w1,int h1) {
if(x<0||x+w1>128||y<0||y+h1>160){return;} 
 tft.setAddrWindow(x,y,x+w1-1,y+h1-1);
 SPI.beginTransaction(SPISettings(40000000, MSBFIRST, SPI_MODE0));
  digitalWrite(TFT_DC, HIGH);
  digitalWrite(TFT_CS, LOW); 
 for(int j=0; j<h; j++) {
    for(int i=0; i<2*w; i=i+2) {
      if(i>=2*x1&&i<2*(x1+w1)&&j>=y1&&j<y1+h1){
       SPI.transfer(bitmap[i+1+j*2*w]);SPI.transfer(bitmap[i+j*2*w]);
      }  
   }
  }
  digitalWrite(TFT_CS, HIGH);
  SPI.endTransaction();
 ///  
}
////////////////////////////////////////////////////////////////////
