//вывод спрайта-картинки на фоновом изображении
#include <Adafruit_GFX.h>
#include <Adafruit_ST7735.h>
#include <SPI.h>
#include "ris_.h"//файл хранения массивов фотокартинок
#define TFT_CS     5
#define TFT_RST    16
#define TFT_DC     17
// TFT_SCL 18   
// TFT_SDA 23 
Adafruit_ST7735 tft = Adafruit_ST7735(TFT_CS,  TFT_DC, TFT_RST);

void setup() {
 tft.initR(INITR_BLACKTAB);
  tft.setRotation(0);
 tft.fillScreen(tft.Color565(0,0,0));
 drawFoto(0,0,ris_3,128,160); 
  }
void loop() {
int x=random(0,95); int y=random(0,135);
drawFoto_spr(x,y,ris_3,128,160,ris_33,32,32,true);
delay(110);
drawFoto_spr(x,y,ris_3,128,160,ris_333,32,32,true);
delay(75);
drawFoto_spr(x,y,ris_3,128,160,ris_33,32,32,true);
delay(110);
drawFoto_spr(x,y,ris_3,128,160,ris_333,32,32,true);
delay(75);
drawFoto_spr(x,y,ris_3,128,160,ris_33,32,32,false);

}
 
/////////////////////////////////////////////////////////////////
//функция вывода спрайта и его стирания по фоновой фотокартинке размером w*h,x,y - положение спрайта на экране w1,h1 - размер спрайта (*bitmap - массив фона,*bitmap_- массив спрайта,true-нарисовать спрайт,false-затереть фоном)  
void drawFoto_spr(int x,int y, const uint8_t *bitmap,int w,int h,const uint8_t *bitmap_,int w1,int h1,bool SPR) {
if(x<0||x+w1>128||y<0||y+h1>160){return;} 
 tft.setAddrWindow(x,y,x+w1-1,y+h1-1);
 SPI.beginTransaction(SPISettings(40000000, MSBFIRST, SPI_MODE0));
  digitalWrite(TFT_DC, HIGH);
  digitalWrite(TFT_CS, LOW); 
 for(int j=0; j<h; j++) {
    for(int i=0; i<2*w; i=i+2) {
      if(i>=2*x&&i<2*(x+w1)&&j>=y&&j<y+h1){
        if(bitmap_[(i-2*x)+1+(j-y)*2*w1]==bitmap_[1]&&bitmap_[(i-2*x)+(j-y)*2*w1]==bitmap_[0]){//условие определения фонового цвета по цвету первого пикселя массива
         SPI.transfer(bitmap[i+1+j*2*w]);SPI.transfer(bitmap[i+j*2*w]);
        }
        else{
        if(SPR) {SPI.transfer(bitmap_[(i-2*x)+1+(j-y)*2*w1]);SPI.transfer(bitmap_[(i-2*x)+(j-y)*2*w1]);}
        else{SPI.transfer(bitmap[i+1+j*2*w]);SPI.transfer(bitmap[i+j*2*w]);} 
        }
      }  
   }
  }
  digitalWrite(TFT_CS, HIGH);
  SPI.endTransaction();
 ///  
}
/////////////////////////////////////////////////////////////////
void drawFoto(int x,int y, const uint8_t *bitmap,int w,int h) {//функция вывода фотокартинки
if(x<0||x+w>128||y<0||y+h>160){return;} 
 tft.setAddrWindow(x,y,x+w-1,y+h-1);
 SPI.beginTransaction(SPISettings(40000000, MSBFIRST, SPI_MODE0));
  digitalWrite(TFT_DC, HIGH);
  digitalWrite(TFT_CS, LOW); 
 for(int j=0; j<h; j++) {
    for(int i=0; i<2*w; i=i+2) {
    SPI.transfer(bitmap[i+1+j*2*w]);SPI.transfer(bitmap[i+j*2*w]);
  // SPI.transfer(pgm_read_byte(bitmap+i+1+j*2*w));SPI.transfer(pgm_read_byte(bitmap+i+j*2*w)); 
    }
  }
  digitalWrite(TFT_CS, HIGH);
  SPI.endTransaction();
 ///  
}
////////////////////////////////////////////////////////////////////

