//вывод фотокартинок и анимация
#include <Adafruit_GFX.h>
#include <Adafruit_ST7735.h>
#include <SPI.h>
#include "ris_.h"//файл хранения массивов фотокартинок
#define TFT_CS     5
#define TFT_RST    16
#define TFT_DC     17
// TFT_SCL 18   
// TFT_SDA 23 
Adafruit_ST7735 tft = Adafruit_ST7735(TFT_CS,  TFT_DC, TFT_RST);
long Y=0;//
int t=25;//
void setup() {
 Serial.begin(9600);
  tft.initR(INITR_BLACKTAB);
 tft.cp437(true);//для правильного отображения русского алфавита 
  tft.setRotation(0);
 tft.fillScreen(tft.Color565(0,0,0)); 
  }
void loop() {
//foto
//появление
for(int n=0;n<=64;n=n+2){
  drawFoto_fragment(64,144-n,ris_0,128,160,64,80,64,n+16);
  drawFoto_fragment(0,0,ris_0,128,160,0,64-n,64,n+16);
  drawFoto_fragment(128-n,0,ris_0,128,160,64,0,n,80);
  drawFoto_fragment(0,80,ris_0,128,160,64-n,80,n,80);
 delay(1*t); 
 }
 //фиксация внимания 
delay(35*t);
tft.setRotation(1);//ориентация экрана
tft.setCursor(20, 110); tft.setTextSize(2); tft.setTextColor(ST7735_YELLOW);tft.println(utf8rus("ТВОЯ МЕЧТА!"));
tft.setRotation(0);
delay(45*t);
drawFoto_fragment(0,0,ris_0,128,160,0,0,128,160);
delay(45*t);
//gif
//анимация
for(byte n=0;n<6;n++){
drawFoto_025(0,0,ris_1,64,80);delay(t);//
drawFoto_025(0,0,ris_2,64,80);delay(t);//
drawFoto_025(0,0,ris_3,64,80);delay(t);//
drawFoto_025(0,0,ris_4,64,80);delay(t);//
drawFoto_025(0,0,ris_5,64,80);delay(t);//
drawFoto_025(0,0,ris_6,64,80);delay(t);//
drawFoto_025(0,0,ris_7,64,80);delay(t);//
drawFoto_025(0,0,ris_8,64,80);delay(t);//
drawFoto_025(0,0,ris_9,64,80);delay(t);//
drawFoto_025(0,0,ris_10,64,80);delay(t);//
drawFoto_025(0,0,ris_11,64,80);delay(t);//
drawFoto_025(0,0,ris_12,64,80);delay(t);//
}
//исчезновение
drawFoto_fragment(0,0,ris_0,128,160,0,0,128,160);
for(int n=0;n<=64;n=n+2){
  fragment_fon(64,144-n,tft.Color565(0,0,0),128,160,64,80,64,n+16);
  fragment_fon(0,0,tft.Color565(0,0,0),128,160,0,64-n,64,n+16);
  fragment_fon(128-n,0,tft.Color565(0,0,0),128,160,64,0,n,80);
  fragment_fon(0,80,tft.Color565(0,0,0),128,160,64-n,80,n,80);
 delay(2*t); 
 }
delay(50*t);
}

////////////////////////////////////////////////////////////////////
void drawFoto_025(int x,int y, const uint8_t *bitmap,int w,int h) {//функция вывода фотокартинки 1 пиксель на 4
if(x<0||x+w>128||y<0||y+h>160){return;} 
 tft.setAddrWindow(x,y,x+2*w-1,y+2*h-1);
 SPI.beginTransaction(SPISettings(40000000, MSBFIRST, SPI_MODE0));
  digitalWrite(TFT_DC, HIGH);
  digitalWrite(TFT_CS, LOW); 
 for(int j=0; j<h; j++) {
    for(int i=0; i<2*w; i=i+2) {
    SPI.transfer(bitmap[i+1+j*2*w]);SPI.transfer(bitmap[i+j*2*w]);
    SPI.transfer(bitmap[i+1+j*2*w]);SPI.transfer(bitmap[i+j*2*w]);
    }
     for(int i=0; i<2*w; i=i+2) {
    SPI.transfer(bitmap[i+1+j*2*w]);SPI.transfer(bitmap[i+j*2*w]);
    SPI.transfer(bitmap[i+1+j*2*w]);SPI.transfer(bitmap[i+j*2*w]);
    }
  }
  digitalWrite(TFT_CS, HIGH);
  SPI.endTransaction();
 ///  
}
////////////////////////////////////////////////////////////////////
//функция вывода фрагмента фотокартинки размером w*h,x,y - положение фрагмента на экране, x1,y1,w1,h1 - выбор фрагмента из массива
void drawFoto_fragment(int x,int y, const uint8_t *bitmap,int w,int h,int x1,int y1,int w1,int h1) {
if(x<0||x+w1>128||y<0||y+h1>160){return;} 
 tft.setAddrWindow(x,y,x+w1-1,y+h1-1);
 SPI.beginTransaction(SPISettings(40000000, MSBFIRST, SPI_MODE0));
  digitalWrite(TFT_DC, HIGH);
  digitalWrite(TFT_CS, LOW); 
 for(int j=0; j<h; j++) {
    for(int i=0; i<2*w; i=i+2) {
      if(i>=2*x1&&i<2*(x1+w1)&&j>=y1&&j<y1+h1){
       SPI.transfer(bitmap[i+1+j*2*w]);SPI.transfer(bitmap[i+j*2*w]);
      }  
   }
  }
  digitalWrite(TFT_CS, HIGH);
  SPI.endTransaction();
 ///  
}
////////////////////////////////////////////////////////////////////
//функция вывода фрагмента фона размером w*h,x,y - положение фрагмента на экране, x1,y1,w1,h1 - выбор фрагмента фона
void fragment_fon(int x,int y,  uint16_t color,int w,int h,int x1,int y1,int w1,int h1) {
if(x<0||x+w1>128||y<0||y+h1>160){return;} 
 tft.setAddrWindow(x,y,x+w1-1,y+h1-1);
 SPI.beginTransaction(SPISettings(40000000, MSBFIRST, SPI_MODE0));
  digitalWrite(TFT_DC, HIGH);
  digitalWrite(TFT_CS, LOW); 
 for(int j=0; j<h; j++) {
    for(int i=0; i<2*w; i=i+2) {
      if(i>=2*x1&&i<2*(x1+w1)&&j>=y1&&j<y1+h1){
       SPI.transfer(color>>8);SPI.transfer(color);
      }  
   }
  }
  digitalWrite(TFT_CS, HIGH);
  SPI.endTransaction();
 ///  
}
////////////////////////////////////////////////////////////////////
/* Функция перекодировки русских букв из UTF-8 в Win-1251 */
String utf8rus(String source)
{
  int i,k;
  String target;
  unsigned char n;
  char m[2] = { '0', '\0' };

  k = source.length(); i = 0;

  while (i < k) {
    n = source[i]; i++;

    if (n >= 0xC0) {
      switch (n) {
        case 0xD0: {
          n = source[i]; i++;
          if (n == 0x81) { n = 0xA8; break; }
          if (n >= 0x90 && n <= 0xBF) n = n + 0x30;
          break;
        }
        case 0xD1: {
          n = source[i]; i++;
          if (n == 0x91) { n = 0xB8; break; }
          if (n >= 0x80 && n <= 0x8F) n = n + 0x70;
          break;
        }
      }
    }
    m[0] = n; target = target + String(m);
  }
return target;
}
////////////////////////////////////////////////////////////////////
